package dev.shadowsoffire.apotheosis.adventure.socket.gem.cutting;

import net.minecraft.client.resources.sounds.SoundInstance;
import net.minecraft.client.resources.sounds.SimpleSoundInstance;
import net.minecraft.client.Minecraft;
import net.minecraft.sounds.SoundSource;
import net.minecraft.sounds.SoundEvents;
import net.minecraft.core.BlockPos;
import net.minecraft.client.resources.sounds.AbstractTickableSoundInstance;
import dev.shadowsoffire.attributeslib.api.AttributeHelper;
import java.util.List;
import dev.shadowsoffire.placebo.reload.DynamicHolder;
import net.minecraft.network.chat.CommonComponents;
import dev.shadowsoffire.apotheosis.adventure.loot.RarityRegistry;
import java.util.ArrayList;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.GemInstance;
import java.util.function.Function;
import dev.shadowsoffire.apotheosis.adventure.affix.salvaging.SalvagingScreen;
import dev.shadowsoffire.apotheosis.adventure.client.GrayBufferSource;
import net.minecraft.world.inventory.Slot;
import net.minecraft.client.gui.GuiGraphics;
import java.util.Iterator;
import net.minecraft.world.level.ItemLike;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixHelper;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import net.minecraft.client.gui.components.Button;
import net.minecraft.client.gui.components.events.GuiEventListener;
import net.minecraft.ChatFormatting;
import dev.shadowsoffire.apotheosis.adventure.Adventure;
import net.minecraft.world.item.Item;
import net.minecraft.world.inventory.AbstractContainerMenu;
import net.minecraft.network.chat.Component;
import net.minecraft.world.entity.player.Inventory;
import dev.shadowsoffire.apotheosis.adventure.client.SimpleTexButton;
import net.minecraft.world.item.ItemStack;
import net.minecraft.resources.ResourceLocation;
import dev.shadowsoffire.apotheosis.adventure.client.AdventureContainerScreen;

public class GemCuttingScreen extends AdventureContainerScreen<GemCuttingMenu>
{
    public static final ResourceLocation TEXTURE;
    protected final ItemStack displayDust;
    protected ItemStack displayMat;
    protected SimpleTexButton upgradeBtn;
    
    public GemCuttingScreen(final GemCuttingMenu pMenu, final Inventory pPlayerInventory, final Component pTitle) {
        super((AbstractContainerMenu)pMenu, pPlayerInventory, pTitle);
        this.displayDust = ((Item)Adventure.Items.GEM_DUST.get()).m_7968_();
        ((GemCuttingMenu)this.f_97732_).addSlotListener((id, stack) -> this.updateBtnStatus());
        this.f_97727_ = 180;
        this.f_97729_ = 5;
        this.f_97731_ = 86;
    }
    
    protected void m_7856_() {
        super.m_7856_();
        final int left = this.getGuiLeft();
        final int top = this.getGuiTop();
        this.upgradeBtn = (SimpleTexButton)this.m_142416_((GuiEventListener)new SimpleTexButton(left + 135, top + 44, 18, 18, 238, 0, GemCuttingScreen.TEXTURE, 256, 256, this::clickUpgradeBtn, (Component)Component.m_237115_("button.apotheosis.upgrade")).setInactiveMessage((Component)Component.m_237115_("button.apotheosis.upgrade.no").m_130940_(ChatFormatting.RED)));
        this.updateBtnStatus();
    }
    
    protected void clickUpgradeBtn(final Button btn) {
        this.f_96541_.f_91072_.m_105208_(((GemCuttingMenu)this.f_97732_).f_38840_, 0);
        GemUpgradeSound.start(((GemCuttingMenu)this.f_97732_).player.m_20183_());
    }
    
    protected void updateBtnStatus() {
        final ItemStack gem = ((GemCuttingMenu)this.f_97732_).m_38853_(0).m_7993_();
        final ItemStack left = ((GemCuttingMenu)this.f_97732_).m_38853_(1).m_7993_();
        final ItemStack bot = ((GemCuttingMenu)this.f_97732_).m_38853_(2).m_7993_();
        final ItemStack right = ((GemCuttingMenu)this.f_97732_).m_38853_(3).m_7993_();
        for (final GemCuttingMenu.GemCuttingRecipe r : GemCuttingMenu.RECIPES) {
            if (r.matches(gem, left, bot, right)) {
                this.upgradeBtn.f_93623_ = true;
                return;
            }
        }
        this.displayMat = (gem.m_41619_() ? ItemStack.f_41583_ : new ItemStack((ItemLike)((LootRarity)AffixHelper.getRarity(gem).get()).getMaterial()));
        if (this.upgradeBtn != null) {
            this.upgradeBtn.f_93623_ = false;
        }
    }
    
    protected void m_7286_(final GuiGraphics gfx, final float pPartialTick, final int pMouseX, final int pMouseY) {
        final int xCenter = (this.f_96543_ - this.f_97726_) / 2;
        final int yCenter = (this.f_96544_ - this.f_97727_) / 2;
        gfx.m_280218_(GemCuttingScreen.TEXTURE, xCenter, yCenter, 0, 0, this.f_97726_, this.f_97727_);
        if (this.hasItem(0) && GemCuttingMenu.isValidMainGem(((GemCuttingMenu)this.f_97732_).m_38853_(0).m_7993_())) {
            if (!this.hasItem(1)) {
                this.renderGrayItem(gfx, this.displayDust, ((GemCuttingMenu)this.f_97732_).m_38853_(1));
            }
            if (!this.hasItem(2)) {
                this.renderGrayItem(gfx, ((GemCuttingMenu)this.f_97732_).m_38853_(0).m_7993_(), ((GemCuttingMenu)this.f_97732_).m_38853_(2));
            }
            if (!this.hasItem(3)) {
                this.renderGrayItem(gfx, this.displayMat, ((GemCuttingMenu)this.f_97732_).m_38853_(3));
            }
        }
    }
    
    protected boolean hasItem(final int slot) {
        return ((GemCuttingMenu)this.f_97732_).m_38853_(slot).m_6657_();
    }
    
    protected void renderGrayItem(final GuiGraphics gfx, final ItemStack stack, final Slot slot) {
        SalvagingScreen.renderGuiItem(gfx, stack, this.getGuiLeft() + slot.f_40220_, this.getGuiTop() + slot.f_40221_, (Function)GrayBufferSource::new);
    }
    
    protected void m_280072_(final GuiGraphics gfx, final int pX, final int pY) {
        final ItemStack gemStack = ((GemCuttingMenu)this.f_97732_).m_38853_(0).m_7993_();
        final GemInstance gem = GemInstance.unsocketed(gemStack);
        final GemInstance secondary = GemInstance.unsocketed(((GemCuttingMenu)this.f_97732_).m_38853_(2).m_7993_());
        final List<Component> list = new ArrayList<Component>();
        if (gem.isValidUnsocketed()) {
            final int dust = ((GemCuttingMenu)this.f_97732_).m_38853_(1).m_7993_().m_41613_();
            final DynamicHolder<LootRarity> rarity = (DynamicHolder<LootRarity>)gem.rarity();
            if (rarity == RarityRegistry.getMaxRarity()) {
                list.add((Component)Component.m_237115_("text.apotheosis.no_upgrade").m_130944_(new ChatFormatting[] { ChatFormatting.GOLD, ChatFormatting.UNDERLINE }));
            }
            else {
                list.add((Component)Component.m_237115_("text.apotheosis.cut_cost").m_130944_(new ChatFormatting[] { ChatFormatting.GOLD, ChatFormatting.UNDERLINE }));
                list.add(CommonComponents.f_237098_);
                final int dustCost = GemCuttingMenu.getDustCost((LootRarity)rarity.get());
                final boolean hasDust = dust > dustCost;
                list.add((Component)Component.m_237110_("text.apotheosis.cost", new Object[] { dustCost, ((Item)Adventure.Items.GEM_DUST.get()).m_7626_(ItemStack.f_41583_) }).m_130940_(hasDust ? ChatFormatting.GREEN : ChatFormatting.RED));
                final boolean hasGem2 = secondary.isValidUnsocketed() && gem.gem() == secondary.gem() && rarity == secondary.rarity();
                list.add((Component)Component.m_237110_("text.apotheosis.cost", new Object[] { 1, gemStack.m_41786_().getString() }).m_130940_(hasGem2 ? ChatFormatting.GREEN : ChatFormatting.RED));
                list.add((Component)Component.m_237115_("text.apotheosis.one_rarity_mat").m_130940_(ChatFormatting.GRAY));
                this.addMatTooltip((DynamicHolder<LootRarity>)RarityRegistry.next((DynamicHolder)rarity), 1, list);
                this.addMatTooltip(rarity, 3, list);
                if (rarity != RarityRegistry.getMinRarity()) {
                    this.addMatTooltip((DynamicHolder<LootRarity>)RarityRegistry.prev((DynamicHolder)rarity), 9, list);
                }
            }
        }
        this.drawOnLeft(gfx, (List)list, this.getGuiTop() + 16);
        super.m_280072_(gfx, pX, pY);
    }
    
    private void addMatTooltip(final DynamicHolder<LootRarity> rarity, final int cost, final List<Component> list) {
        final Item rarityMat = ((LootRarity)rarity.get()).getMaterial();
        final ItemStack slotMat = ((GemCuttingMenu)this.f_97732_).m_38853_(3).m_7993_();
        final boolean hasMats = slotMat.m_41720_() == rarityMat && slotMat.m_41613_() >= cost;
        list.add((Component)AttributeHelper.list().m_7220_((Component)Component.m_237110_("text.apotheosis.cost", new Object[] { cost, rarityMat.m_7626_(ItemStack.f_41583_) }).m_130940_(hasMats ? ChatFormatting.YELLOW : ChatFormatting.RED)));
    }
    
    static {
        TEXTURE = new ResourceLocation("apotheosis", "textures/gui/gem_cutting.png");
    }
    
    protected static class GemUpgradeSound extends AbstractTickableSoundInstance
    {
        protected int ticks;
        protected float pitchOff;
        
        public GemUpgradeSound(final BlockPos pos) {
            super(SoundEvents.f_144242_, SoundSource.BLOCKS, Minecraft.m_91087_().f_91073_.f_46441_);
            this.ticks = 0;
            this.f_119575_ = pos.m_123341_() + 0.5f;
            this.f_119576_ = pos.m_123342_();
            this.f_119577_ = pos.m_123343_() + 0.5f;
            this.f_119573_ = 1.5f;
            this.f_119574_ = 1.5f + 0.35f * (1.0f - 2.0f * this.f_235066_.m_188501_());
            this.pitchOff = 0.35f * (1.0f - 2.0f * this.f_235066_.m_188501_());
            this.f_119579_ = 999;
        }
        
        public void m_7788_() {
            if (this.ticks == 4 || this.ticks == 9) {
                Minecraft.m_91087_().m_91106_().m_120367_((SoundInstance)SimpleSoundInstance.m_119755_(SoundEvents.f_144242_, this.f_119574_ + this.pitchOff, 1.5f));
                this.pitchOff = -this.pitchOff;
            }
            if (this.ticks++ > 8) {
                this.m_119609_();
            }
        }
        
        public static void start(final BlockPos pos) {
            Minecraft.m_91087_().m_91106_().m_120367_((SoundInstance)new GemUpgradeSound(pos));
        }
    }
}
